local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 38407 $"):match("%d+"))

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

ThreatLib_funcs[#ThreatLib_funcs+1] = function()

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

-- You need to register the module with the localized mob name, as this is used to 
local c = "Firewing Warlock"

ThreatLib:GetModule("NPCCore"):SetModuleDefaultState(c, false)
local FirewingWarlock = ThreatLib:GetModule("NPCCore"):NewModule(c)

local triggerStrings = {
	["enUS"] = "%s attempts to run away in fear!",
	["deDE"] = nil,
	["frFR"] = nil,
	["koKR"] = nil,
	["zhTW"] = nil,
}

function FirewingWarlock:Init()
	local phase2 = triggerStrings[_G.GetLocale()]
	triggerStrings = nil

	self:RegisterCombatant("Firewing Warlock", true)
	
	-- To register a callback to a yell or emote:
	-- self:RegisterChatEvent([yell|event], localizedMobName, yellOrEmoteToTriggerOn, callbackFunction)
	-- self:RegisterChatEvent("yell", BB["Attumen the Huntsman"], phaseThree, self.PhaseThree)
	
	self:RegisterChatEvent("emote", "Firewing Warlock", phase2, self.phaseTransition)
end

-- StartFight is called when you engage any of the mobs registered by RegisterCombatant()
-- Use it to reset any state that you need to maintain in the module (like self.SetNumberOfMobs)
function FirewingWarlock:StartFight()
	-- SetNumberOfMobs is used as a divisor for global threat. Be sure to set it correctly, and to account for mob deaths during the fight
	-- If you are unsure of the participants, or you want to just be safe, leave this at 1
	self:SetNumberOfMobs(1)
end

function FirewingWarlock:phaseTransition()
	self:Print("Got trigger emote, wiping raid threat")
	self:SetNumberOfMobs(1)
	self:WipeRaidThreatOnMob("Firewing Warlock")
end

table.insert(ThreatLib.UpvalueFixers, function(lib)
	ThreatLib = lib
	FirewingWarlock = ThreatLib:GetModule("NPCCore"):GetModule(c)
end)

end
