local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 37586 $"):match("%d+"))

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

ThreatLib_funcs[#ThreatLib_funcs+1] = function()

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

-- You need to register the module with the localized mob name, as this is used to 
local c = BB["Terestian Illhoof"]

local ThreatLibNPCModuleCore = ThreatLib:GetModule("NPCCore")
ThreatLibNPCModuleCore:SetModuleDefaultState(c, false)
local Illhoof = ThreatLibNPCModuleCore:NewModule(c)

local impNames = {
	["enUS"] = "Kil'rek",
	["deDE"] = nil,
	["frFR"] = nil,
	["koKR"] = nil,
	["zhTW"] = nil,
}

local triggerStrings = {
	["enUS"] = "%s shrieks in pain and points at his master.",
	["deDE"] = nil,
	["frFR"] = nil,
	["koKR"] = nil,
	["zhTW"] = nil,
}

function Illhoof:Init()
	local killed = triggerStrings[_G.GetLocale()]
	triggerStrings = nil

	self.impName = impNames[_G.GetLocale()]
	impNames = nil

	if self.impName then
		self:RegisterCombatant(self.impName, self.clearKilrekThreat)
	end
	self:RegisterCombatant(BB["Terestian Illhoof"], true)
	
	-- To register a callback to a yell or emote:
	-- self:RegisterChatEvent([yell|event], localizedMobName, yellOrEmoteToTriggerOn, callbackFunction)
	-- self:RegisterChatEvent("yell", BB["Attumen the Huntsman"], phaseThree, self.PhaseThree)
	-- self:RegisterChatEvent("emote", self.impName, killed, self.clearKilrekThreat)
end

-- StartFight is called when you engage any of the mobs registered by RegisterCombatant()
-- Use it to reset any state that you need to maintain in the module (like self.SetNumberOfMobs)
function Illhoof:StartFight()
	-- SetNumberOfMobs is used as a divisor for global threat. Be sure to set it correctly, and to account for mob deaths during the fight
	-- If you are unsure of the participants, or you want to just be safe, leave this at 1
	self:SetNumberOfMobs(1)
end

function Illhoof:clearKilrekThreat()
	self:WipeRaidThreatOnMob(self.impName)
end

end