local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 38407 $"):match("%d+"))

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

ThreatLib_funcs[#ThreatLib_funcs+1] = function()

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

-- You need to register the module with the localized mob name, as this is used to 
local c = BB["Nightbane"]

ThreatLib:GetModule("NPCCore"):SetModuleDefaultState(c, false)
local Nightbane = ThreatLib:GetModule("NPCCore"):NewModule(c)

local triggerStrings = {
	["enUS"] = "Miserable vermin. I shall exterminate you from the air!",
	["deDE"] = "Abscheuliches Gew\195\188rm! Ich werde euch aus der Luft vernichten!",
	["frFR"] = "Misérable vermine. Je vais vous exterminer des airs !",
	["koKR"] = "이 더러운 기생충들, 내가 하늘에서 너희의 씨를 말리리라!",
	["zhTW"] = "悲慘的害蟲。我將讓你消失在空氣中!"	
}

local skeletonNames = {
	["enUS"] = "Restless Skeleton",
	["deDE"] = nil,
	["frFR"] = nil,
	["koKR"] = nil,
	["zhTW"] = nil
}

function Nightbane:Init()
	local airPhase = triggerStrings[_G.GetLocale()]
	triggerStrings = nil
	
	-- You can register Joe The Noob as a combatant in this fight, and set a handler to be called on his death
	-- self:RegisterCombatant(BB["Joe the Noob"], self.HandleJoeDeath)
	
	-- Alternately, if the second parameter is true, then the fight is over when Joe dies.
	-- self:RegisterCombatant(BB["Joe the Noob"], true)

	self:RegisterCombatant(BB["Nightbane"], true)
	self.skellyName = skeletonNames[_G.GetLocale()]
	if skellyName then
		self:RegisterCombatant(self.skellyName, self.skellyDeath)
	end

	-- To register a callback to a yell or emote:
	-- self:RegisterChatEvent([yell|event], localizedMobName, yellOrEmoteToTriggerOn, callbackFunction)
	-- self:RegisterChatEvent("yell", BB["Attumen the Huntsman"], phaseThree, self.PhaseThree)
	
	self:RegisterChatEvent("yell", BB["Nightbane"], airPhase, self.phaseTransition)
end

-- StartFight is called when you engage any of the mobs registered by RegisterCombatant()
-- Use it to reset any state that you need to maintain in the module (like self.SetNumberOfMobs)
function Nightbane:StartFight()
	-- SetNumberOfMobs is used as a divisor for global threat. Be sure to set it correctly, and to account for mob deaths during the fight
	-- If you are unsure of the participants, or you want to just be safe, leave this at 1
	self:SetNumberOfMobs(1)
end

function Nightbane:skellyDeath()
	self:SetNumberOfMobs(self:GetNumberOfMobs() - 1)
end

function Nightbane:phaseTransition()
	if self.skellyName then
		self:SetNumberOfMobs(6)		-- Nightbane + 5 skeletons
		self:WipeRaidThreatOnMob(self.skellyName)
	end	
	self:WipeRaidThreatOnMob("Nightbane")
end

table.insert(ThreatLib.UpvalueFixers, function(lib)
	ThreatLib = lib
	Nightbane = ThreatLib:GetModule("NPCCore"):GetModule(c)
end)

end
